""
PROJECTNAME "benchmark update" .
PROJECTCATEGORY  .

CLASS SCOMPLEX
INCLUDEDEF=1
CLASSMETHODS *
INSTANCEMETHODS *

CLASS FFTBenchmark
INCLUDEDEF=0
CLASSMETHODS 
BEGIN
END
INSTANCEMETHODS 
BEGIN
	exptab:
	FFTn:z:w:e:sqrinv:
	newComplexArray:
	run
END
! !
Struct variableByteSubclass: #SCOMPLEX
	classVariableNames: ''
	poolDictionaries: ''
	comment: ''
	category: ''!

!SCOMPLEX class .EXTERN methods 08:58 - 02/16/02!
initialize
	"
	Private - Initialize the definition dictionaries.
	"
	super initialize.
	self
		addAccessor: #rp   type: FT_DOUBLE  size: LONG_DOUBLE;
		addAccessor: #ip   type: FT_DOUBLE  size: LONG_DOUBLE! !

!FFTBenchmark methods 09:23 - 02/16/02!
exptab: n
	
	"Returns an initialized 'e' complex array"
	"n is FFTSize"
	
	| "float"           theta divisor 
	  "Array(float)"    h 
	  "Array(SComplex)" e
	  "int"             i j k l m 
	  "SCOMPLEX"        sc1 sc2 sc3 |
	  
	theta := 3.1415926536.
	divisor := 4.0.
	h := Array new: 25.
	e := self newComplexArray: (n // 2 + 1).
	 
	1 to: 25 do: [ :ii |
		h at: ii put: (1.0/(2.0 * (self cos: (theta/divisor)))).
		divisor := divisor + divisor.
	].
	
	m := n // 2.
	l := m // 2.
	j := 1.
	(e at: 1) rp: 1.0.
	(e at: 1) ip: 0.0.
	(e at: l+1) rp: 0.0.
	(e at: l+1) ip: 1.0.
	(e at: m+1) rp: -1.0.
	(e at: m+1) ip: 0.0.
	
	[
		i := l // 2.
		k := i.
		
		[ 
			sc1 := e at: k+1. sc1 _as: SCOMPLEX.
			sc2 := e at: k+i+1. sc1 _as: SCOMPLEX.
			sc3 := e at: k-i+1. sc1 _as: SCOMPLEX.
			
			sc1 rp: ((h at: j) * sc2 rp + sc3 rp).
			sc1 ip: ((h at: j) * sc2 ip + sc3 ip).
			k := k + l.
			k <= m   "test"
		] whileTrue: [].
		
		j := j+1 min: 25.
		l := i.
		l > 1  "test"
	] whileTrue: [].
	
	^e! !

!FFTBenchmark methods 08:58 - 02/16/02!
FFTn: n z: z w: w e: e sqrinv: sqrinv

	"Compute FFT - Based on C implementation
	 n = number of elements in main arrays
	 z = array1 (modified)
	 w = array2 (modified)
	 e = smaller array
	 sqrinv = some constsant
	 It would be nice if someone would fill out the real meanings of these."
	
	| i j k l m e1 e2 e3 e4 e5 e6|   "All integers"
	
	m := n // 2.
	l := 1.
	
	[
		k := 0.
		j := l.
		i := 1.
		
		[
			[
				e1 := w at: i+k. e1 _as: SCOMPLEX.
				e2 := z at: i.   e2 _as: SCOMPLEX.
				e3 := z at: m+i. e3 _as: SCOMPLEX.
				e4 := w at: i+j. e4 _as: SCOMPLEX.
				e5 := e at: k+1. e5 _as: SCOMPLEX.
				
				e1 rp: e2 rp + e3 rp.
				e1 ip: e2 ip + e3 rp.
				e4 rp:   (e5 rp * (e2 rp - e3 rp))
				                - (e5 ip * (e2 ip - e3 ip)).
				e4 ip:   (e5 rp * (e2 ip - e3 ip))
				                + (e5 ip * (e2 rp - e3 rp)).
				i := i + 1.
				i <= j   "test"
			] whileTrue: [].
			
			k := j.
			j := k + l.
			j <= m   "test"
		] whileTrue: [].
		
		1 to: m do: [ :index | 
			z at: index put: (w at: index) copy.
		].
		
		l := l+l.     "l:=l*2"
		l <= m  "test"
	] whileTrue: [].
	
	1 to: n do: [ :index |
		e6 := z at: index. e6 _as: SCOMPLEX.
		
		e6 rp: sqrinv * e6 rp.
		e6 ip: sqrinv * e6 ip.
	].! !

!FFTBenchmark methods 08:58 - 02/16/02!
newComplexArray: size
	
	"Return an array of SComplex elemtns of a given length"
	
	| a |
	
	a := Array new: size.
	1 to: size do: [ :i | a at: i put: SCOMPLEX new ].
	^a! !

!FFTBenchmark methods 08:58 - 02/16/02!
run
	| z e w fftSeed elt|
	
	e := self exptab: FFTSize.
	fftSeed := 5767.
	z := self newComplexArray: FFTSize.
	w := self newComplexArray: FFTSize.
	
	1 to: FFTSize do: [ :i |
		seed := self random8K: fftSeed.  
		elt := z at: i.
		elt _as: SCOMPLEX.
		elt rp: (20.0 * (fftSeed / 8192.0)) - 10.0.
		seed := self random8K: fftSeed.
		elt rp: (20.0 * (fftSeed / 8192.0)) - 10.0.
	].
	
	1 to: 20 do: [ :i |
		self FFTn: FFTSize z: z w: w e: e sqrinv: 0.0625.
	].! !

