"Second half of SELF-BEN.ST"

"*****************************************************************************"

Quicksort2Benchmark subclass: #TreeSort2Benchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!TreeSort2Benchmark someMethodsFor: 'misc'!

run
	| tree |
	self initarr.
	tree _ TreeSort2Node new contents: (sortlist at: 1).
	2 to: self n do: [:i | tree insert: (sortlist at: i)].
	tree checkTree or: [self error: 'error'].
	"TreeSort2Benchmark new run"! !

!TreeSort2Benchmark someMethodsFor: 'constants'!

cTimes: mach
	mach = 'sun4_260' ifTrue: [^780].
	mach = 'sun3_160' ifTrue: [^1160].
 mach = 'macIIcx'  ifTrue: [^1183]!

fixedBase ^2.5! !

"*****************************************************************************"

AbstractBenchmark subclass: #QueensBenchmark
	instanceVariableNames: ''
	classVariableNames: 'Queencount '
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!QueensBenchmark someMethodsFor: 'run'!

run
	Queencount timesRepeat: [self doQueens]! !

!QueensBenchmark someMethodsFor: 'private'!

doQueens
	| i a b c x |
	a _ Array new: 9.
	b _ Array new: 17.
	c _ Array new: 15.
	x _ Array new: 9.
	i _ -7.
	[i <= 16]
		whileTrue: 
			[(i >= 1 and: [i <= 8])
				ifTrue: [a at: i put: true].
			i >= 2 ifTrue: [b at: i put: true].
			i <= 7 ifTrue: [c at: i + 8 put: true].
			i _ i + 1].
	(self
		tryI: 1
		A: b
		B: a
		C: c
		X: x)
		ifFalse: [self error: 'Error in queens']!

tryI: i A: a B: b C: c X: x 
	| j q |
	j _ 0.
	q _ false.
	[q not and: [j ~= 8]]
		whileTrue: 
			[j _ j + 1.
			q _ false.
			((b at: j)
				and: [(a at: i + j)
						and: [c at: i - j + 8]])
				ifTrue: 
					[x at: i put: j.
					b at: j put: false.
					a at: i + j put: false.
					c at: i - j + 8 put: false.
					i < 8
						ifTrue: 
							[q _ self
										tryI: i + 1
										A: a
										B: b
										C: c
										X: x.
							q
								ifFalse: 
									[b at: j put: true.
									a at: i + j put: true.
									c at: i - j + 8 put: true]]
						ifFalse: [q _ true]]].
	^q! !

!QueensBenchmark someMethodsFor: 'constants'!

cTimes: mach 
	mach = 'sun4_260' ifTrue: [^90].
	mach = 'sun3_160' ifTrue: [^532].
 mach = 'macIIcx'  ifTrue: [^300]!

fixedBase ^1.83! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "

"----- GVG
QueensBenchmark class
	instanceVariableNames: ''
 -----"!

!QueensBenchmark class someMethodsFor: 'constants'!

initialize Queencount _ 50 "QueensBenchmark initialize"! !

QueensBenchmark initialize!


"*****************************************************************************"

IntMMBenchmark subclass: #PuzzleBenchmark
	instanceVariableNames: 'piececount class piecemax puzzl p n kount '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!PuzzleBenchmark someMethodsFor: 'private'!

fitI: i J: j 
	0 to: (piecemax at: i)
		do: [:k | (  ((p at: i) at: k) 
				and: [(puzzl at: j + k) ])
				ifTrue: [^false]].
	^true!

placeI: i J: j 
	0 to: (piecemax at: i)
		do: [:k | ((p at: i) at: k)
				ifTrue: [puzzl at: j + k put: true]].
	piececount at: (class at: i)
		put: (piececount at: (class at: i)) - 1.
	j to: self puzzleSize do: [:k | (puzzl at: k) ifFalse: [^k]].
	^0!

removeI: i J: j 
	0 to: (piecemax at: i)
		do: [:k | ((p at: i) at: k)
				ifTrue: [puzzl at: j + k put: false]].
	piececount at: (class at: i)
		put: (piececount at: (class at: i))
				+ 1!

run1
	piececount _ PuzzleArray new: self classmax + 1.
	class _ PuzzleArray new: self typemax + 1.
	piecemax _ PuzzleArray new: self typemax + 1.
	puzzl _ PuzzleArray new: self puzzleSize + 1.
	p _ self makePuzzleMatrix: self typemax + 1 by: self puzzleSize + 1.
	0 to: self puzzleSize do: [:m | puzzl at: m put: true]!

run2  
	1 to: 5 do: [ :i |
	    1 to: 5 do: [ :j |
	        1 to: 5 do: [ :k |
		    puzzl at: i + (self d * (j + (self d * k))) put: false ]]].

	0 to: self typemax   do: [ :i |
	    0 to: self puzzleSize   do: [ :m |
		(p at: i) at: m put: false]].

	0 to: 3 do: [ :i | 0 to: 1 do: [ :j | 0 to: 0 do: [ :k | (p at: 0) at: i + (self d * (j + (self d * k))) put: true ]]].
	class at: 0 put: 0.
	piecemax at: 0 put: 3 + (self d * 1) + (self d * self d * 0).

	0 to: 1 do: [ :i | 0 to: 0 do: [ :j | 0 to: 3 do: [ :k | (p at: 1) at: i + (self d * (j + (self d * k))) put: true ]]].
	class at: 1 put: 0.
	piecemax at: 1 put: 1 + (self d * 0) + (self d * self d * 3).

	0 to: 0 do: [ :i | 0 to: 3 do: [ :j | 0 to: 1 do: [ :k | (p at: 2) at: i + (self d * (j + (self d * k))) put: true ]]].
	class at: 2 put: 0.
	piecemax at: 2 put: 0 + (self d * 3) + (self d * self d * 1).

	0 to: 1 do: [ :i | 0 to: 3 do: [ :j | 0 to: 0 do: [ :k | (p at: 3) at: i + (self d * (j + (self d * k))) put: true ]]].
	class at: 3 put: 0.
	piecemax at: 3 put: 1 + (self d * 3) + (self d * self d * 0).

	0 to: 3 do: [ :i | 0 to: 0 do: [ :j | 0 to: 1 do: [ :k | (p at: 4) at: i + (self d * (j + (self d * k))) put: true ]]].
	class at: 4 put: 0.
	piecemax at: 4 put: 3 + (self d * 0) + (self d * self d * 1).

	0 to: 0 do: [ :i | 0 to: 1 do: [ :j | 0 to: 3 do: [ :k | (p at: 5) at: i + (self d * (j + (self d * k))) put: true ]]].
	class at: 5 put: 0.
	piecemax at: 5 put: 0 + (self d * 1) + (self d * self d * 3).

	0 to: 2 do: [ :i | 0 to: 0 do: [ :j | 0 to: 0 do: [ :k | (p at: 6) at: i + (self d * (j + (self d * k))) put: true ]]].
	class at: 6 put: 1.
	piecemax at: 6 put: 2 + (self d * 0) + (self d * self d * 0).

	0 to: 0 do: [ :i | 0 to: 2 do: [ :j | 0 to: 0 do: [ :k | (p at: 7) at: i + (self d * (j + (self d * k))) put: true ]]].
	class at: 7 put: 1.
	piecemax at: 7 put: 0 + (self d * 2) + (self d * self d * 0).

	0 to: 0 do: [ :i | 0 to: 0 do: [ :j | 0 to: 2 do: [ :k | (p at: 8) at: i + (self d * (j + (self d * k))) put: true ]]].
	class at: 8 put: 1.
	piecemax at: 8 put: 0 + (self d * 0) + (self d * self d * 2).

	0 to: 1 do: [ :i | 0 to: 1 do: [ :j | 0 to: 0 do: [ :k | (p at: 9) at: i + (self d * (j + (self d * k))) put: true ]]].
	class at: 9 put: 2.
	piecemax at: 9 put: 1 + (self d * 1) + (self d * self d * 0).

	0 to: 1 do: [ :i | 0 to: 0 do: [ :j | 0 to: 1 do: [ :k | (p at: 10) at: i + (self d * (j + (self d * k))) put: true ]]].
	class at: 10 put: 2.
	piecemax at: 10 put: 1 + (self d * 0) + (self d * self d * 1).

	0 to: 0 do: [ :i | 0 to: 1 do: [ :j | 0 to: 1 do: [ :k | (p at: 11) at: i + (self d * (j + (self d * k))) put: true ]]].
	class at: 11 put: 2.
	piecemax at: 11 put: 0 + (self d * 1) + (self d * self d * 1).

	0 to: 1 do: [ :i | 0 to: 1 do: [ :j | 0 to: 1 do: [ :k | (p at: 12) at: i + (self d * (j + (self d * k))) put: true ]]].
	class at: 12 put: 3.
	piecemax at: 12 put: 1 + (self d * 1) + (self d * self d * 1).!

trial: j 
	| k |
	kount _ kount + 1.
	0 to: self typemax do: [:i | (piececount at: (class at: i))
			~= 0 ifTrue: [(self fitI: i J: j)
				ifTrue: 
					[k _ self placeI: i J: j.
					((self trial: k)
						or: [k = 0])
						ifTrue: [^true]
						ifFalse: [self removeI: i J: j]]]].
	^false! !

!PuzzleBenchmark someMethodsFor: 'constants'!

classmax ^3!

cTimes: mach 
	mach = 'sun4_260' ifTrue: [^760].
	mach = 'sun3_160' ifTrue: [^5726].
 mach = 'macIIcx'  ifTrue: [^1900]!

d ^8!

fixedBase ^0.5!

puzzleSize ^511!

typemax ^12! !

!PuzzleBenchmark someMethodsFor: 'run'!

run
	| m |
	n _ 0.
	kount _ 0.
	self run1; run2.
	piececount at: 0 put: 13.
	piececount at: 1 put: 3.
	piececount at: 2 put: 1.
	piececount at: 3 put: 1.
	m _ 1 + (self d * (1 + (self d * 1))).
	kount _ 0.
	(self fitI: 0 J: m) ifTrue: [n _ self placeI: 0 J: m] ifFalse: [self error: 'error1 in puzzle'].
	(self trial: n ) ifFalse: [self error: 'error2 in puzzle'].
	kount = 2005 ifFalse: [self error: 'error3 in puzzle']! !

"*****************************************************************************"

AbstractBenchmark subclass: #SieveBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!SieveBenchmark someMethodsFor: 'misc'!

run
	| size iter flags prime k |
	size _ 8190.
	iter _ 10.
	flags _ (Array new: size + 1)
				atAllPut: true.
	iter timesRepeat: [
		0 to: size do: [:i | (flags at: i + 1) ifTrue: [
			prime _ i + i + 3.
			k _ i + prime.
			[k <= size] whileTrue: [
				flags at: k put: false.
				k _ k + prime]]]]
	"SieveBenchmark new run"! !

IntMMBenchmark subclass: #IntMM2Benchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!IntMM2Benchmark someMethodsFor: 'run'!

run
	| m |
	self initrand.
	m _ ((IntMM2Matrix new: IRowsize by: IRowsize) init: self) * ((IntMM2Matrix new: IRowsize by: IRowsize) init: self).
	^m
	"IntMM2Benchmark new run"! !

"*****************************************************************************"

AbstractBenchmark subclass: #AtAllPutBenchmark
	instanceVariableNames: ''
	classVariableNames: 'Vect '
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!AtAllPutBenchmark someMethodsFor: 'misc'!

run
	"AtAllPutBenchmark new run"
	Vect atAllPut: 7! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "

"----- GVG
AtAllPutBenchmark class
	instanceVariableNames: ''
 -----"!

!AtAllPutBenchmark class someMethodsFor: 'initialize'!

initialize
	"AtAllPutBenchmark initialize"
	Vect _ Array new: 100000! !

AtAllPutBenchmark initialize!


"*****************************************************************************"

AbstractBenchmark subclass: #Queens2Benchmark
	instanceVariableNames: 'freeMajs freeRows freeMins qrows '
	classVariableNames: 'Queencount '
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!Queens2Benchmark someMethodsFor: 'run'!

run
	Queencount timesRepeat: [self initialize doQueens]
	"Queens2Benchmark new run"! !

!Queens2Benchmark someMethodsFor: 'private'!

doQueens
	(self try: 1) 
		ifFalse: [self error: 'Error in queens']!

initialize
	freeMajs _ (Array new: 15) atAllPut: true.
	freeRows _ (Array new: 8) atAllPut: true.
	freeMins _ (Array new: 15) atAllPut: true.
	qrows _ Array new: 8.!

try: col
	1 to: 8 do: [ :row |
		((freeRows at: row) and: [(freeMajs at: col + row - 1) and: [freeMins at: col - row + 7]]) ifTrue: [
			qrows at: col put: row.
			freeRows at: row put: false.
			freeMajs at: col + row - 1 put: false.
			freeMins at: col - row + 7 put: false.
			8 = col ifTrue: [ ^true ].
			(self try: col + 1 ) ifTrue: [^true].
			freeRows at: row put: true.
			freeMajs at: col + row - 1 put: true.
			freeMins at: col - row + 7 put: true] ].
	^false! !

!Queens2Benchmark someMethodsFor: 'constants'!

cTimes: mach 
	mach = 'sun4_260' ifTrue: [^90].
	mach = 'sun3_160' ifTrue: [^532].
 mach = 'macIIcx'  ifTrue: [^300]!

fixedBase ^1.83! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "

"----- GVG
Queens2Benchmark class
	instanceVariableNames: ''
 -----"!

!Queens2Benchmark class someMethodsFor: 'constants'!

initialize Queencount _ 50 "Queens2Benchmark initialize"! !

Queens2Benchmark initialize!


"*****************************************************************************"

IntMMBenchmark subclass: #MMBenchmark
	instanceVariableNames: ''
	classVariableNames: 'Rowsize '
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!MMBenchmark someMethodsFor: 'constants'!

cTimes: mach 
	mach = 'sun4_260' ifTrue: [^320].
	mach = 'sun3_160' ifTrue: [^6718].
 mach = 'macIIcx'  ifTrue: [^817] "18983 if not optimized for 68881"!

fixedBase ^0.73!

floatBase ^2.92! !

!MMBenchmark someMethodsFor: 'private'!

initmatrix 
	| m temp |
	m _ self mmMatrix.
	1 to: Rowsize do: [:i | 1 to: Rowsize do: 
			[:j | 
			temp _ self newValue.
			(m at: i)
				at: j put: temp - (temp / 120 * 120) - 60]].
	^m!

newValue
	^super newValue asFloat! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "

"----- GVG
MMBenchmark class
	instanceVariableNames: ''
 -----"!

!MMBenchmark class someMethodsFor: 'constants'!

initialize Rowsize _ 40 "MMBenchmark initialize"! !

MMBenchmark initialize!

"*****************************************************************************"

AtAllPutBenchmark subclass: #SumAllBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!SumAllBenchmark someMethodsFor: 'misc'!

run
	| sum |
	sum _ 0.
	Vect do: [ :i | sum _ sum + 1 ].
	^ sum! !

"*****************************************************************************"

Quicksort2Benchmark subclass: #BubbleSort2Benchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!BubbleSort2Benchmark someMethodsFor: 'misc'!

arrayClass ^BubbleSort2Array!

n ^500! !

!BubbleSort2Benchmark someMethodsFor: 'constants'!

cTimes: mach
	mach = 'sun4_260' ifTrue: [^180].
	mach = 'sun3_160' ifTrue: [^942].
 mach = 'macIIcx'  ifTrue: [^633]!

fixedBase ^ 1.61! !

"*****************************************************************************"

AbstractBenchmark subclass: #TaklBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!TaklBenchmark someMethodsFor: 'misc'!

listn: n
	0 = n ifTrue: [ ^ nil ] ifFalse: [ ^ (Cons new car: n) cdr: (self listn: n - 1) ]!

run
	"TaklBenchmark new run"
	| r |
	r _ self taklX: (self listn: 18) Y: (self listn: 12) Z: (self listn: 6).
	(r = (self listn: 7)) ifFalse: [ self error: 'takl results are wrong' ]!

shorterpX: x Y: y
	^ (nil ~= y) and: [ (nil = x) or: [ self shorterpX: x cdr Y: y cdr ] ]!

taklX: x Y: y Z: z
	(self shorterpX: y Y: x) ifFalse: [^z]
		ifTrue: [^self
				taklX: (self
						taklX: x cdr
						Y: y
						Z: z)
				Y: (self
						taklX: y cdr
						Y: z
						Z: x)
				Z: (self
						taklX: z cdr
						Y: x
						Z: y)]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "

"----- GVG
TaklBenchmark class
	instanceVariableNames: ''
 -----"!

"*****************************************************************************"

AtAllPutBenchmark subclass: #IncrementAllBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!IncrementAllBenchmark someMethodsFor: 'misc'!

run
	"IncrementAllBenchmark new run"
	1 to: Vect size do: [ :i | Vect at: i put: (Vect at: i) + 1. ]! !

"*****************************************************************************"

QuicksortBenchmark subclass: #BubbleSortBenchmark
	instanceVariableNames: 'top '
	classVariableNames: 'Sortelements SortElements '
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!BubbleSortBenchmark someMethodsFor: 'run'!

initarr
	| temp |
	self initrand.
	biggest _ -1000000.
	littlest _ 1000000.
	sortlist _ Array new: Sortelements.
	1 to: Sortelements do: 
		[:i | 
		temp _ self rand.
		sortlist at: i put: temp - (temp // 100000 * 100000) - 50000.
		(sortlist at: i)
			> biggest ifTrue: [biggest _ sortlist at: i].
		(sortlist at: i)
			< littlest ifTrue: [littlest _ sortlist at: i]]!

run   | i  j |
	self initarr.
	top _    Sortelements.
	[top > 1] whileTrue: [
	    i_ 1.
	    [i < top] whileTrue: [
		(sortlist at: i) > (sortlist at: i + 1) ifTrue: [
		    j_ sortlist at: i.
		    sortlist at: i put: (sortlist at: i + 1).
		    sortlist at: i + 1 put: j.
		].
		i_ i + 1.
	    ].
	    top_ top - 1.
	].
	((sortlist at: 1) ~= littlest or: 
	[(sortlist at: Sortelements) ~= biggest]) ifTrue:
	    [self error: 'Error3 in Bubble'  ]! !

!BubbleSortBenchmark someMethodsFor: 'constants'!

cTimes: mach 
	mach = 'sun4_260' ifTrue: [^180].
	mach = 'sun3_160' ifTrue: [^942].
 mach = 'macIIcx'  ifTrue: [^633]!

fixedBase ^ 1.61! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "

"----- GVG
BubbleSortBenchmark class
	instanceVariableNames: ''
 -----"!

!BubbleSortBenchmark class someMethodsFor: 'constants'!

initialize Sortelements _ 500 "BubbleSortBenchmark initialize"! !

BubbleSortBenchmark initialize!

"*****************************************************************************"

IntMM2Benchmark subclass: #MM2Benchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!MM2Benchmark someMethodsFor: 'misc'!

newValue ^super newValue asFloat! !

!MM2Benchmark someMethodsFor: 'constants'!

cTimes: mach
	mach = 'sun4_260' ifTrue: [^320].
	mach = 'sun3_160' ifTrue: [^6718].
 mach = 'macIIcx'  ifTrue: [^817] "18983 if not optimized for 68881"!

fixedBase ^0.73!

floatBase ^2.92! !



"*****************************************************************************"

AbstractBenchmark subclass: #Towers2Benchmark
	instanceVariableNames: 'stack movesdone '
	classVariableNames: 'Maxcells Sentinel Stackrange '
	poolDictionaries: ''
	category: 'Self-Benchmarks'!


!Towers2Benchmark someMethodsFor: 'constants'!

cTimes: mach 
	mach = 'sun4_260' ifTrue: [^190].
	mach = 'sun3_160' ifTrue: [^1130].
 mach = 'macIIcx'  ifTrue: [^1134]!

fixedBase
	^2.39! !

!Towers2Benchmark someMethodsFor: 'run'!

makenull: s
	stack at: s put: Sentinel!

run
	stack _ Array new: Stackrange.
	self makenull: 1.
	self makenull: 2.
	self makenull: 3.
	self init: 1 to: 14.
	movesdone _ 0. 
	self
		towerI: 1
		j: 2
		k: 14.
	movesdone = 16383 ifFalse: [self error: ' Error in towers.'].
	"Towers2Benchmark new run"! !

!Towers2Benchmark someMethodsFor: 'private'!

error: msg
	super error: 'Error in towers: ', msg! !

!Towers2Benchmark someMethodsFor: 'misc'!

init: s to: n 

	n
		to: 1
		by: -1
		do: [:discctr | self push: (Towers2Disk new discSize: discctr) onto: s]!

moveFrom: s1 to: s2 
	self push: (self pop: s1)
		onto: s2.
	movesdone _ movesdone + 1!

pop: s 
	| result |
	Sentinel == (stack at: s) ifTrue: [self error: 'empty'].
	result _ stack at: s.
	stack at: s put: result next.
	^result!

push: d onto: s 
	| localel |
	localel _ stack at: s.
	d >= localel ifTrue: [^self error: 'disc size error'].
	stack at: s put: (d next: localel)!

towerI: i j: j k: k 
	| other |
	k = 1
		ifTrue: [self moveFrom: i to: j]
		ifFalse: 
			[other _ 6 - i - j.
			self
				towerI: i
				j: other
				k: k - 1.
			self moveFrom: i to: j.
			self
				towerI: other
				j: j
				k: k - 1]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "

"----- GVG
Towers2Benchmark class
	instanceVariableNames: ''
 -----"!

!Towers2Benchmark class someMethodsFor: 'constants'!

initialize Maxcells _ 18. Stackrange _ 3. Sentinel _ Towers2Disk new discSize: 15. "Towers2Benchmark initialize"! !

Towers2Benchmark initialize!

