# ----------------------------- bench.py ----------------------------------

# Python version of Stanford Integer Benchmarks

starttime = clock()
Bubble()
print "Time for bubble sort is", int((clock() - starttime)*1000), "ms"

# -------------------------- Module Variables ------------------------------

srtelements = 500
seed = 74755

# ------------------------- Utility Functions ------------------------------

def Initrand():
	#Initialize seed for random number generator
	global seed
	seed = 74755

def Rand():
	#A very poor random number generator
	global seed
	seed = (seed * 1309 + 13849) & 65535
	return seed


# ---------------------------- Bubble Sort ---------------------------------

def Bubble():
    # "Bubble sort benchmark - creates and sorts an array of size srtelements."
	(sortlist, littlest, biggest) = bInitArr(srtelements)
	top = srtelements
	while top > 1:
		i = 1
		while i < top:
			if sortlist[i] > sortlist[i+1]:
				j = sortlist[i]
				sortlist[i] = sortlist[i+1]
				sortlist[i+1] = j
			i = i + 1
		top = top - 1
	if sortlist[1] != littlest  or sortlist[srtelements] != biggest:
		print "Error3 in Bubble"
	else:
		print "Bubble sort completed"

def bInitArr(zsize):
    # "Initializes array with random values for bubble sort benchmark"
	Initrand()
	sortlist = [0]    #Start with an extra element at 0 which is unused
	biggest = 0
	littlest = 0
	for i in range(zsize):
		temp = Rand()
		sortlist.append( temp - (temp/100000)*100000 - 50000 )
		if sortlist[i] > biggest:
			biggest = sortlist[i]
		elif sortlist[i] < littlest:
			littlest = sortlist[i]
	return (sortlist, littlest, biggest)
